#include <Arduino.h>
#include <Wire.h>
#include <homekit/main.h>
#include <homekit/mqtt/mqtt.h>
#include <homekit/mqtt/module/temphum.h>
#include <homekit/temphum.h>

using namespace homekit;
using main::LoopConfig;
using mqtt::Mqtt;
using mqtt::MqttTemphumModule;

temphum::Sensor* sensor = nullptr;
MqttTemphumModule* mqttTemphumModule = nullptr;

static void onMqttCreated(Mqtt& mqtt);

LoopConfig loopConfig = {
        .onMqttCreated = onMqttCreated
};

void setup() {
    main::setup();

#if CONFIG_MODULE == HOMEKIT_SI7021
    sensor = new temphum::Si7021();
#elif CONFIG_MODULE == HOMEKIT_DHT12
    sensor = new temphum::DHT12();
#endif
    sensor->setup();
}

void loop() {
    main::loop(&loopConfig);
}

static void onMqttCreated(Mqtt& mqtt) {
    if (mqttTemphumModule == nullptr) {
        mqttTemphumModule = new MqttTemphumModule(sensor);
        mqtt.addModule(mqttTemphumModule);
    }
}